%{
#include "crt/stdio.bi"
#include "crt/ctype.bi"
#include "crt/time.bi"

Dim Shared regs(0 To 26) As Integer
Dim Shared base As Integer
Type field1 As Double
Type field2 As Integer
Type field3 As UByte
%}

%union {
  Dim first As field1
  Dim second As field2
  Dim third As field3
}

%start list

%token <first> DIGIT
%token <third> LETTER

%type <first> number
%type <first> expr

%left "|"
%left "&"
%left "+" "-"
%left "*" "/" "%"
%left UMINUS   /* supplies precedence for unary minus */

%% /* beginning of rules section */

list  :  /* empty */
      |  list stat "\n"
      |  list error "\n"
            {  yyerrok }
      ;

stat  :  expr
            {  Print Using "#####";$1}
      |  LETTER "=" expr
            {  regs($1) = $3 }
      ;

expr  :  "(" expr ")"
            {  $$ = $2 }
      |  expr "+" expr
            {  $$ = $1 + $3 }
      |  expr "-" expr
            {  $$ = $1 - $3 }
      |  expr "*" expr
            {  $$ = $1 * $3 }
      |  expr "/" expr
            {  $$ = $1 / $3 }
      |  expr "%" expr
            {  $$ = $1 Mod $3 }
      |  expr "&" expr
            {  $$ = $1 And $3 }
      |  expr "|" expr
            {  $$ = $1 Or $3 }
      |  "-" expr %prec UMINUS
            {  $$ = - $2 }
      |  LETTER
            {  $$ = regs($1) }
      |  number
      ;

number:  DIGIT
         {  $$ = $1
            If ($1 = 0) Then
              base = 8
            Else
              base = 10
            End If
            /' comment '/
         }
      |  number DIGIT
         {  $$ = base * $1 + $2 }
      ;

%% /' start of programs '/

Dim Shared in_hndl As Integer

Sub main ()	
    in_hndl = FreeFile()
    
    Open "inin.txt" For Input As #in_hndl
    
    Var t1 = clock()
    Do Until(EOF(in_hndl))
      yyparse()
    Loop
    Var t2 = clock()
    Print Using "Start = ###########";t1
    Print Using "End   = ###########";t2
    Close #in_hndl		

End Sub

Sub yyerror_(ByVal s As ZString Ptr)   
   Print *s
End Sub

#define ULA 97  'Asc("a")
#define ULZ 122 'Asc("z")
#define UD0 48  'Asc("0")
#define UD9 57  'Asc("9")
#define USPC 32 'Asc(" ")

Function yylex() As Integer

      /' lexical analysis routine '/
      /' returns LETTER for a lower case letter, yylval = 0 through 25 '/
      /' return DIGIT for a digit, yylval = 0 through 9 '/
      /' all other characters are returned immediately '/

      Dim c As UByte
      
      Get #in_hndl,,c
      While (c = USPC)
        Get #in_hndl,,c
      Wend     
      
      
      'C is not whitespace
      Select Case As Const(c)
      Case ULA To ULZ
        yylval.third = c - ULA
        Return LETTER
      Case UD0 To UD9
        yylval.first = c - UD0
        Return DIGIT
      End Select
      
      Return(c)
      
End Function

main()