/* $Id: skeleton.c,v 1.19 2008/12/24 14:52:28 tom Exp $ */

#include "defs.h"

/*  The definition of yysccsid in the banner should be replaced with  */
/*  a #pragma ident directive if the target C compiler supports    */
/*  #pragma ident directives.            */
/*                  */
/*  If the skeleton is changed, the banner should be changed so that  */
/*  the altered version can be easily distinguished from the original.  */
/*                  */
/*  The #defines included with the banner are there because they are  */
/*  useful in subsequent code.  The macros #defined in the header or  */
/*  the body either are not useful outside of semantic actions or  */
/*  are conditional.              */

const char *banner[] =
{
    "#ifndef lint",
    "Static yysccsid As ZString Ptr = @\"@(#)yaccpar  1.9 (Berkeley) 02/21/93\"",
    "#endif",
    "",
    "#include \"crt/stdlib.bi\"",
    "#include \"crt/string.bi\"",
    "",
    "#define YYBYACC 1",
    CONCAT1("#define YYMAJOR ", YYMAJOR),
    CONCAT1("#define YYMINOR ", YYMINOR),
#ifdef YYPATCH
    CONCAT1("#define YYPATCH ", YYPATCH),
#endif
    "",
    "#define YYEMPTY        (-1)",
    "#define yyclearin      yychar = YYEMPTY",
    "#define yyerrok        yyerrflag = 0",		
    "#define YYRECOVERING() yyerrflag <> 0",
    "",
    "/' compatibility with bison '/",
    "#ifdef YYPARSE_PARAM",
    "  /' compatibility with FreeBSD '/",
    "  #ifdef YYPARSE_PARAM_TYPE",
    "    #define YYPARSE_DECL() yyparse(YYPARSE_PARAM_TYPE YYPARSE_PARAM)",
    "  #else",
    "    #define YYPARSE_DECL() yyparse(YYPARSE_PARAM As Any Ptr)",
    "  #endif",
    "#else",
    "  #define YYPARSE_DECL() yyparse()",
    "#endif /' YYPARSE_PARAM '/",
    "",
    "Declare Function YYPARSE_DECL() As Integer",
    "",
    "Declare Function yygrowstack() As Integer",
    0
};

const char *tables[] =
{
    "extern short yylhs[];",
    "extern short yylen[];",
    "extern short yydefred[];",
    "extern short yydgoto[];",
    "extern short yysindex[];",
    "extern short yyrindex[];",
    "extern short yygindex[];",
    "extern short yytable[];",
    "extern short yycheck[];",
    "",
    "#if YYDEBUG",
    "extern char *yyname[];",
    "extern char *yyrule[];",
    "#endif",
    0
};

const char *header[] =
{
    "#if YYDEBUG",
    "  #include \"crt/stdio.bi\"",
    "#endif",
    "",
    "/' define the initial stack-sizes '/",
    "#ifdef YYSTACKSIZE",
    "  #undef YYMAXDEPTH",
    "  #define YYMAXDEPTH  YYSTACKSIZE",
    "#else",
    " #ifdef YYMAXDEPTH",
    "   #define YYSTACKSIZE YYMAXDEPTH",
    " #else",
    "   #define YYSTACKSIZE 500",
    "  #define YYMAXDEPTH  500",
    " #endif",
    "#endif",
    "",
    "#define YYINITSTACKSIZE 500",
    "",
    "Dim Shared yydebug_ As Integer",
    "Dim Shared yynerrs As Integer",
    "Dim Shared yyerrflag As Integer",
    "Dim Shared yychar As Integer",
    "Dim Shared yyssp As Short Ptr",
    "Dim Shared yyvsp As YYSTYPE Ptr",
    "Dim Shared yyval As YYSTYPE",
    "Dim Shared yylval As YYSTYPE",
    "",
    "/' variables for the parser stack '/",
    "Static Shared yyss As Short Ptr",
    "Static Shared yysslim As Short Ptr",
    "Static Shared yyvs As YYSTYPE Ptr",
    "Static Shared yystacksize_ As UInteger",
    0
};

const char *body[] =
{
    "/\' allocate initial stack or double stack size, up to YYMAXDEPTH \'/",
    "Function yygrowstack() As Integer",
    "",
    "    Dim i As Integer",
    "    Dim newsize As UInteger",
    "    Dim newss As Short Ptr",
    "    Dim newvs As YYSTYPE Ptr",
    "    Dim tmp As UInteger",  
    "",    
		"    tmp = yystacksize_",		
    "    If(tmp = 0) Then",
    "        newsize = YYINITSTACKSIZE",
    "    Else",
    "      If (newsize >= YYMAXDEPTH) Then",
    "        Return -1",
    "      Else",
    "        If ((newsize * 2) > YYMAXDEPTH) Then",
    "          newsize = YYMAXDEPTH",
    "        End If",
    "      End If",
    "    End If",
    "    i = yyssp - yyss",
    "    If (yyss <> 0) Then",
    "      newss = Cast(Short Ptr,realloc(yyss, newsize * SizeOf(*newss)))",
    "    Else",
    "      newss = Cast(Short Ptr,malloc(newsize * SizeOf(*newss)))",
    "    End If",
    "    If (newss = 0) Then",
    "        Return -1",
    "    End If",
    "    yyss  = newss",
    "    yyssp = newss + i",
    "    If (yyvs <> 0) Then",
    "      newvs = Cast(YYSTYPE Ptr,realloc(yyvs, newsize * SizeOf(*newvs)))",
    "    Else",
    "      newvs = Cast(YYSTYPE Ptr, malloc(newsize * SizeOf(*newvs)))",
		"    End If",
    "    If (newvs = 0) Then",
    "        Return -1",
    "    End If",
    "    yyvs = newvs",
    "    yyvsp = newvs + i",
    "    yystacksize_ = newsize",
    "    yysslim = yyss + newsize - 1",
    "    Return 0",
    "End Function",
    "",
    "#define YYABORT  Goto yyabort_",
    "#define YYREJECT Goto yyabort_",
    "#define YYACCEPT Goto yyaccept_",
    "#define YYERROR  Goto yyerrlab",
    "",
    "",
    "Function YYPARSE_DECL() As Integer",
    "",
    "    Dim yym As Integer",
    "    Dim yyn As Integer",
    "    Dim yystate As Integer",
    "#if YYDEBUG",
    "    \'FBCHANGE",
		"    Dim yys As ZString Ptr",
    "",
		"    yydebug_ = 1",    
    "#endif",
    "",
    "    yynerrs = 0",
    "    yyerrflag = 0",
    "    yychar = YYEMPTY",
    "    yystate = 0",
    "",
    "    If (yyss = NULL AndAlso yygrowstack()) Then",
    "      Goto yyoverflow",
    "    End If",
    "    yyssp = yyss",
    "    yyvsp = yyvs",
    "    yystate = 0",
    "    *yyssp = 0",
    "",
    "yyloop:",
    "    \'FBCHANGE",
		"    yyn = yydefred(yystate)",
		"    If (yyn <> 0) Then",
    "      Goto yyreduce",
    "    End If",
    "    If (yychar < 0) Then",    
    "      \'FBCHANGE",
		"      yychar = yylex()",
		"      If (yychar < 0) Then",
    "        yychar = 0",
    "      End If",
    "#if YYDEBUG",
    "        If (yydebug_) Then",
    "          yys = 0",
    "          If (yychar <= YYMAXTOKEN) Then",
    "            yys = yyname(yychar)",
    "          End If",
    "          If (yys = 0) Then",
    "            *yys = \"illegal-symbol\"",
    "            \'FBCHANGE",
		"            printf(\!\"%sdebug: state %d, reading %d (%s)\\n\", _",
    "                  YYPREFIX, yystate, yychar, yys)",
    "          End If",
    "        End If",
    "#endif",
    "    End If",
    "    \'FBCHANGE",
		"    yyn = yysindex(yystate)",
		"    If (yyn <> 0) Then",
		"      yyn += yychar",
		"      If (yyn >= 0 AndAlso yyn <= YYTABLESIZE AndAlso yycheck(yyn) = yychar) Then",
    "#if YYDEBUG",
    "        If (yydebug_) Then",
    "          printf(\!\"%sdebug: state %d, shifting to state %d\\n\", _",
    "                  YYPREFIX, yystate, yytable(yyn))",
    "        End If",
    "#endif",
    "        If (yyssp >= yysslim AndAlso yygrowstack()) Then",    
    "          Goto yyoverflow",
    "        End If",
    "        yystate = yytable(yyn)",
    "        yyssp += 1:*yyssp = yytable(yyn)",
    "        yyvsp += 1:*yyvsp = yylval",
    "        yychar = YYEMPTY",
    "        If (yyerrflag > 0) Then",
    "          yyerrflag -= 1",
    "        End If",
    "        Goto yyloop",
    "      End If",
		"    End If",
    "    \'FBCHANGE",
		"    yyn = yyrindex(yystate)",
		"    If (yyn <> 0) Then",
		"      yyn += yychar",
		"      If (yyn >= 0 AndAlso yyn <= YYTABLESIZE AndAlso yycheck(yyn) = yychar) Then",    
    "        yyn = yytable(yyn)",		
    "        Goto yyreduce",
		"      End If",
    "    End If",
    "    If (yyerrflag) Then",
    "      Goto yyinrecovery",
    "    End If",
    "",
    "    yyerror_(\"syntax error\")",
    "",
    "    Goto yyerrlab",
    "",
    "yyerrlab:",
    "    yynerrs += 1",
    "",
    "yyinrecovery:",
    "    If (yyerrflag < 3) Then",    
    "      yyerrflag = 3",
    "      While(1)",    
    "         \'FBCHANGE",
		"         yyn = yysindex(*yyssp)",
		"         If (yyn <> 0) Then",
		"           yyn += YYERRCODE",
		"           If (yyn >= 0 AndAlso yyn <= YYTABLESIZE AndAlso yycheck(yyn) = YYERRCODE) Then",    
    "#if YYDEBUG",
    "             \'FBCHANGE",
		"             If (yydebug_) Then",
    "               printf(\!\"%sdebug: state %d, error recovery shifting to state %d\\n\", _",
    "                       YYPREFIX, *yyssp, yytable(yyn))",
    "             End If",
    "#endif",
    "             If (yyssp >= yysslim AndAlso yygrowstack()) Then",
    "               Goto yyoverflow",
    "             End If",
    "             yystate = yytable(yyn)",
    "             yyssp += 1:*yyssp  = yytable(yyn)",
    "             yyvsp += 1:*yyvsp = yylval",
    "             Goto yyloop",
		"           Else",
		"             \'FB_CHANGE",
		"             Goto outer_else",
		"           End If",
    "         Else",
		"'FBCHANGE",
		"outer_else:",
    "#if YYDEBUG",
    "          \'FBCHANGE",
		"          If (yydebug_) Then",
    "            printf(\!\"%sdebug: error recovery discarding state %d\\n\",_",
    "                   YYPREFIX, *yyssp)",
    "          End If",
    "#endif",
    "          If (yyssp <= yyss) Then",
    "            Goto yyabort_",
    "          End If",
    "          yyssp -= 1",
    "          yyvsp -= 1",
    "        End If",
    "      Wend",    
    "    Else",    
    "      If (yychar = 0) Then",
    "        Goto yyabort_",
    "      End If",
    "#if YYDEBUG",
    "      If (yydebug_) Then",    
    "        yys = 0",
    "        If (yychar <= YYMAXTOKEN) Then",
    "          yys = yyname(yychar)",
    "        End If",
    "        If (yys = 0) Then",
    "          *yys = \"illegal-symbol\"",
    "        End If",
    "        \'FBCHANGE",
		"        printf(\!\"%sdebug: state %d, error recovery discards token %d (%s)\\n\", _",
    "                YYPREFIX, yystate, yychar, yys)",
    "      End If",
    "#endif",
    "      yychar = YYEMPTY",
    "      Goto yyloop",
    "    End If",
    "",
    "yyreduce:",
    "#if YYDEBUG",
    "    \'FBCHANGE",
		"    If (yydebug_) Then",
    "      printf(\!\"%sdebug: state %d, reducing by rule %d (%s)\\n\", _",
    "             YYPREFIX, yystate, yyn, yyrule(yyn))",
    "    End If",
    "#endif",
    "    yym = yylen(yyn)",
    "    If (yym) Then",
    "      yyval = yyvsp[1-yym]",
    "    Else",
    "      memset(@yyval, 0, SizeOf(yyval))",
    "    End If",
    "    \'FBCHANGE",
		"    Select Case As Const(yyn)",    
    0
};

const char *trailer[] =
{
    "    End Select",
    "    yyssp -= yym",
    "    yystate = *yyssp",
    "    yyvsp -= yym",
    "    yym = yylhs(yyn)",
    "    If (yystate = 0 AndAlso yym = 0) Then",    
    "#if YYDEBUG",
    "      \'FBCHANGE",
		"      If (yydebug_) Then",
    "        printf(\!\"%sdebug: after reduction, shifting from state 0 to state %d\\n\" _",
    "        ,YYPREFIX, YYFINAL)",
    "      End If",
    "#endif",
    "      yystate = YYFINAL",
    "      yyssp +=1:  *yyssp = YYFINAL",
    "      yyvsp += 1: *yyvsp = yyval",
    "      If (yychar < 0) Then",    
    "        \'FBCHANGE",
		"        yychar = yylex()",
		"        If (yychar < 0) Then",
    "          yychar = 0",
    "        End If",
    "#if YYDEBUG",
    "        If (yydebug_) Then",    
    "          yys = 0",
    "          If (yychar <= YYMAXTOKEN) Then",
    "            yys = yyname(yychar)",
    "          End If",
    "          If (yys = 0) Then",
    "             *yys = \"illegal-symbol\"",
    "          End If",
    "          \'FBCHANGE",
		"          printf(\!\"%sdebug: state %d, reading %d (%s)\\n\", _",
    "                  YYPREFIX, YYFINAL, yychar, yys)",
    "        End If",
    "#endif",
    "      End If",
    "      If (yychar = 0) Then",
    "        Goto yyaccept_",
    "      End If",
    "      Goto yyloop",
    "    End If",
    "    \'FBCHANGE",
		"    yyn = yygindex(yym)",
		"    If (yyn <> 0) Then",
		"      yyn += yystate",
		"      If (yyn >= 0 AndAlso yyn <= YYTABLESIZE AndAlso yycheck(yyn) = yystate) Then",
    "        yystate = yytable(yyn)",
    "      Else",
    "        yystate = yydgoto(yym)",
		"      End If",
		"    Else",
		"      yystate = yydgoto(yym)",
    "    End If",
    "#if YYDEBUG",
    "    If (yydebug_) Then",
    "      printf(\!\"%sdebug: after reduction, shifting from state %d to state %d\\n\" _ ",
    "             ,YYPREFIX, *yyssp, yystate)",
    "    End If",
    "#endif",
    "    If (yyssp >= yysslim AndAlso yygrowstack()) Then",
    "      Goto yyoverflow",
    "    End If",
    "    yyssp += 1: *yyssp = Cast(Short,yystate)",
    "    yyvsp += 1: *yyvsp = yyval",
    "    Goto yyloop",
    "",
    "yyoverflow:",
    "    yyerror_(\"yacc stack overflow\")",
    "",
    "yyabort_:",
    "    Return (1)",
    "",
    "yyaccept_:",
    "    Return (0)",
    "End Function",
    0
};

void
write_section(const char *section[])
{
    int c;
    int i;
    const char *s;
    FILE *f;

    f = code_file;
    for (i = 0; (s = section[i]) != 0; ++i)
    {
  ++outline;
  while ((c = *s) != 0)
  {
      putc(c, f);
      ++s;
  }
  putc('\n', f);
    }
}
